About data flow model diagrams (Gane-Sarson notation)

Show me an example

You can design data flow models using the Data Flow Model Diagram template, which includes shapes for all the symbols used in the Gane-Sarson notation.

The Data Flow Model template uses a top-down design strategy for creating data flow diagrams. You begin by creating top-level processes. Then you decompose each process into subprocesses for more detail.

This solution provides a DFD Model Explorer and semantic error checking so you can easily navigate between levels in a diagram and ensure equivalence at boundaries in your DFD diagrams.

For information about the Gane-Sarson method, see Structured Systems Analysis: Tools and Techniques, by C. Gane and T. Sarson (New York: IST, Inc., 1977). Also see Conceptual Database Design, by Carlo Batini, Stefano Ceri, and Shamkant B. Navathe (Redwood City, Ca.: The Benjamin/Cummings Publishing Company, Inc., 1992).

Create a data flow model diagram (Gane-Sarson notation)


Create a data flow model diagram (Gane-Sarson notation)

Show me an example

  1. On the File menu, point to New, point to Software, and then click Data Flow Model Diagram.
  2. Create the top-level detail page for the diagram by dragging Interface, Process shapes from the Gane-Sarson stencil onto the drawing page.

Click to show or hide information. Add a new data flow model element to a diagram

Drag the shape representing the element you want to add to a diagram from the Gane-Sarson stencil onto the drawing page.

An icon representing the new data flow model element appears in the tree view.

Click to show or hide information. Tip

You can also add a data flow model element to a diagram by creating a new element in the tree view. Right-click an element icon, and then click Duplicate. Drag the element from the tree view onto the drawing page.

As you add the shapes to the page, icons that represent the shapes appear in the DFD Model Explorer.

Note In this template, you must use a top-down design strategy for your data flow model diagram. Start the model at the top level and drill down to lower levels.

Click to show or hide information. Duplicate a shape

Right-click a process icon in the DFD Model Explorer, and then click Duplicate.

A new process icon is added to the model (and appears in the tree view).

To add the process to a detail page, drag the process icon onto the page.

Click to show or hide information. Delete a shape

Right-click a process icon in the DFD Model Explorer, and then click Delete.

The process is removed from the model (in the tree view) and also removed from any detail pages on which it appeared.

Click to show or hide information. Rename a shape

  1. Right-click the shape's icon in the DFD Model Explorer, and then click Rename.
  2. Type the new name text. The new name for the shape appears next to its icon in the model (in the tree view) and the shape name is automatically updated on each detail page on which it appears.

  3. Connect Interface, Process, and Data Store shapes to each other using Data Flow connectors.

Click to show or hide information. Change the data flow direction

Reconnect the data flow with the arrow pointing to the correct shape.

  4. Add a detail page for each process. Your detail pages can include subprocesses that require additional detail pages.

Click to show or hide information. Add a detail page

Do one of the following:

  • Right-click a process shape on the page and then click New Detail Page.
  • Right-click a process icon in the DFD Model Explorer, and then click New Sub-Process.
  • Select a process shape on the page, then choose DFD, and then click New Detail Page.

  5. Optional: If you add a data flow to a process on a higher level page, and that process already has a detail page, you can import the data flow on the detail page to balance the diagram.

Click to show or hide information. Import data flows to balance a diagram

  1. On a detail page, choose DFD, and then click Import Data Flows. The list of data flows that need to be balanced on the process detail appears in the Import Data Flows dialog box.
  2. Check each data flow you want to import, and then click OK.

  6. Continue adding detail pages for each process (including interface, process, and data store shapes as needed, connected by data flows) until you have described the entire data flow model system in sufficient detail.


DFD Options dialog box (Gane-Sarson notation)

Set options for the Data Flow Model Diagram template that determine default behavior for the DFD Model Explorer window and Status window, and for dragging and deleting DFD shapes.

Click to show or hide information. Shape Ctrl-Drag behavior

Choose one of the following to specify the result you get when you hold down the CTRL key and drag a data flow model shape:

  • Copy model view only

Check this option to create a view of the element on the drawing page.

  • Copy model element

Check this option to automatically duplicate the data flow model element the shape represents and give the element a new name.

Click to show or hide information. Prompt for model element(s) delete on delete of shape(s)

When this prompt is checked, you are prompted to choose to delete either the shape alone or both the shape and the model element each time you delete a shape from a diagram.

If this option is unchecked, the element is deleted from the tree view and all views of the element are deleted from the diagram.

Click to show or hide information. Check semantic errors on DFD models

Check this option to use semantic error checking for the model. Uncheck this option to turn semantic error checking off. This option is unchecked by default.


Import Data Flows dialog box (Gane-Sarson notation)

In the list of missing data flows, check each data flow you want to import, and then click OK.


DFD Diagram dialog box (Gane-Sarson notation)

Use the DFD Diagram dialog box to navigate to an existing diagram in which the element appears.

Click to show or hide information. Select Diagram

Lists the existing data flow model diagrams in which the selected element appears. Select a diagram from the list, and then click OK to display it.


Data flow model diagram example (Gane-Sarson notation)

Data flow model diagram detailing certification process, including subprocesses and interfaces.


About the Model Explorer

When you create a data flow model diagram, the model appears as a hierarchical tree view in the Model Explorer window. Data flow elements are represented by icons in the tree view.

When you drag a data flow model shape onto the drawing page, a corresponding icon is added to the tree view. If you delete a data flow model element from the tree view, the element is deleted from any diagram pages on which it appears. However, if you delete an element from a diagram page, it remains in the tree view.

The Model Explorer opens docked on the left side of the screen by default. You can move the Model Explorer so that it floats, resize the window by dragging one of its borders, or dock the window in another location by dragging it to any edge of the drawing page window.

Click to show or hide information. Tip

To hide or to show the Model Explorer, on the DFD menu, point to View, and then click Model Explorer.


About the Output window

When a data flow element has a semantic error because the element has been improperly used according to Gane-Sarson notation, a message about the error appears in the Output window. To locate a particular element in the Model Explorer tree view or in a diagram so you can fix an error, double-click its error message in this window.

The Ouput window opens docked on the bottom right of the screen by default. You can move the Ouput window so that it floats, resize the window by dragging one of its borders, or dock the window in another location by dragging it to any edge of the drawing page window.

Click to show or hide information. Tip

To show or hide the Ouput window, from the DFD menu, point to View, and then click Ouput.


About the data flow model diagram interface (Gane-Sarson notation)

The Data Flow Model Diagram solution provides a DFD Model Explorer so you can easily navigate between levels in a diagram, and semantic error checking to ensure equivalence at boundaries in your DFD diagrams. These and other data flow model interface elements are described below.

Click to show or hide information. DFD Model Explorer

When you open a new data flow model drawing file, the DFD Model Explorer opens by default docked on the left side of the screen. You can change the default settings so that the DFD Model Explorer window floats.

The DFD Model Explorer contains the tree view.

Tree view

When you create a data flow model, the model appears as a hierarchical tree view in this window. DFD model elements are represented by icons in the tree view.

Click to show or hide information. Output window

When you open a new data flow model drawing file, the Output window opens docked on the bottom right of the screen by default. You can move the Output window so that it floats, resize the window by dragging one of its borders, or dock the window in another location by dragging it to any edge of the drawing page window.

Errors

In the Data Flow Model Diagram solution, you have the option of turning semantic error checking on or off. This option is unchecked by default.

When a data flow model element has a semantic error, a message about the error appears in the Errors window. To locate a particular element in the tree view or in a diagram so you can fix an error, double-click its error message in this window.

Click to show or hide information. Detail pages for subprocesses

You can create a detail page for each subprocess in a data flow model diagram. When you add a new detail page, any DFD model elements required to ensure equivalence at boundaries are automatically added to that page.

Detail pages represent the different levels in your data flow model diagram.

If you add one or more data flows to a process on a higher level page, and that process already has a detail page, you can import the data flow(s) on the detail page to balance the diagram.


About syntax rules for data flow models (Gane-Sarson notation)

  • All shapes on each detail page must be interconnected with data flows.
  • A process can't originate data. (It must somehow be receiving data from an interface or a data store or a process.)
  • Names of elements must be unique within each category (data stores must have different names).
  • A process must send data somewhere. (It can't only receive the data and not send it.)
  • If more than one data flow exists with the same source and target, these data flows must have different names.
  • Data flows must be connected to a process (on start or end).
  • Data flows must be connected at both ends.
  • Data flows can't be connected to the same shape at both ends (a loop).


Set options for working with a data flow model (Gane-Sarson notation)

  1. On the DFD menu, click Options to set the default behavior for the DFD Model Explorer window and the Output window, for dragging and deleting data flow model shapes, and for semantic error checking.
  2. Check or select the options you want, and then click OK.


Add detail pages and subprocesses to a data flow model (Gane-Sarson notation)

Do one of the following:

  • Right-click a process shape on the page and then click New Detail Page.
  • Right-click a process icon in the DFD Model Explorer, and then click New Sub-Process.
  • Select a process shape on the page, then choose DFD, and then click New Detail Page.


Navigate between levels in the data flow model (Gane-Sarson notation)

Do one of the following:

  • Select a process on the page, then choose DFD, and then click Go To Detail Page. If the process has a detail page, that page appears.
  • Double-click a process icon in the DFD Model Explorer tree view.
  • Click the Page tab [image] in the bottom-left corner of the window for the detail page you want to see.


Locate and diagnose errors in a data flow model (Gane-Sarson notation)

In the Data Flow Model Diagram solution, you have the option of turning semantic error checking on or off. This option is unchecked by default.

Click to show or hide information. Control semantic error checking in a model

Choose DFD, and then click Options. In the DFD Options dialog box, check or uncheck the Check semantic errors on DFD models option.

When you use the semantic error checking option, all semantic and syntactical errors appear red on the page as you add elements to the data flow model, and the descriptions of these errors or warnings are displayed in the Errors tab of the Output window.

In addition, a shape in a diagram turns red when it represents an element with an error. Read an error message to get a brief explanation of the nature of an error.

Click to show or hide information. Locate an element associated with an error message

Double-click the error message. The Data Flow Model Diagram solution indicates the element that contains the error by selecting its icon in the tree view or by displaying a diagram and selecting its shape on the drawing page.

Click to show or hide information. Tip

To change the size of the Errors window, drag one of its borders. To open or close the Errors window, choose DFD, and then click Output Window.


Import a data flow to balance a detail page (Gane-Sarson notation)

Note If you add a data flow to a process on a higher level page and that process already has a detail page, you will need to import the data flow(s) and place them on the detail page to balance the diagram.

  1. On a detail page, choose DFD, and then click Import Data Flows. The list of data flows that need to be balanced on the process detail appears in the Import Data Flows dialog box.
  2. Check each data flow you want to import, and then click OK.


Work with data flow model shapes (Gane-Sarson notation)

Click to show or hide information. Duplicate a shape

Right-click a process icon in the DFD Model Explorer, and then click Duplicate.

A new process icon is added to the model (and appears in the tree view).

To add the process to a detail page, drag the process icon onto the page.

Click to show or hide information. Delete a shape

Right-click a process icon in the DFD Model Explorer, and then click Delete.

The process is removed from the model (in the tree view) and also removed from any detail pages on which it appeared.

Click to show or hide information. Rename a shape

  1. Right-click the shape's icon in the DFD Model Explorer, and then click Rename.
  2. Type the new name text. The new name for the shape appears next to its icon in the model (in the tree view) and the shape name is automatically updated on each detail page on which it appears.


Change the data flow direction (Gane-Sarson notation)

Reconnect the data flow with the arrow pointing to the correct shape.


About data flow models and elements (Gane-Sarson notation)

To understand how to add elements to a data flow model, you first need to understand the distinction between a diagram and a model.

Models appear in a hierarchical tree view in the DFD Model Explorer window.

Diagrams are views of a model that are represented by icons in the tree view and by drawing pages in your data flow model diagram drawing file.

Keep the following information in mind when you use the data flow model solution:

  • You can add elements to a diagram by dragging icons from the tree view or shapes from stencils onto the drawing page.
  • When you drag a shape onto the drawing page, the shape becomes part of the model and elements that represent the shapes are automatically added to the tree view as icons.
  • When you add an element to the tree view, that element does not appear in a diagram unless you drag the icon representing the element from the tree view onto a drawing page.
  • You can duplicate elements in the tree view.
  • You can add different views of the same element to detail pages by dragging the element's icon from the tree view onto different pages.


Add a new element to a data flow model diagram (Gane-Sarson notation)

Drag the shape representing the element you want to add to a diagram from the Gane-Sarson stencil onto the drawing page.

An icon representing the new data flow model element appears in the tree view.

Click to show or hide information. Tip

You can also add a data flow model element to a diagram by creating a new element in the tree view. Right-click an element icon, and then click Duplicate. Drag the element from the tree view onto the drawing page.